//+------------------------------------------------------------------+
//|                                                    bbsqueeze.mq4 |
//|                Copyright  2005, Nick Bilak, beluck[AT]gmail.com |
//|           enhanced a little bit by CJ Rivas, carlos[AT]vealo.com
///           changed to hma squeeze by tools                        //
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nick Bilak"
#property link      "http://metatrader.50webs.com/"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Maroon
#property indicator_color5 Red
#property indicator_color6 Lime
#property indicator_level1 0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor PaleVioletRed




extern string TimeFrame            = "Current time frame";
extern int    LRegrPeriod          = 20;
extern int    Method               = 8;
extern int    Lag                  = 20;
extern int    NumberOfComputations = 2;
extern int    NumberOfBars         = 500;
extern int    Price                = PRICE_CLOSE;
extern bool   DataDisplayOff       = false;
extern bool   Interpolate          = true;
extern bool   alertsOn             = false;
extern bool   alertsOnCurrent      = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;

//
//
//
//
//

double upB[];
double upB2[];
double loB[];
double loB2[];
double upK[];
double loK[];
double value[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;



int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,upB);
      SetIndexBuffer(1,loB);  
      SetIndexBuffer(2,upB2); 
      SetIndexBuffer(3,loB2);
      SetIndexBuffer(4,upK);
      SetIndexBuffer(5,loK);
      SetIndexBuffer(6,value);
      SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
   
      if (DataDisplayOff)
      {
         SetIndexStyle(0,DRAW_NONE);
         SetIndexStyle(1,DRAW_NONE);
         SetIndexStyle(2,DRAW_NONE);
         SetIndexStyle(3,DRAW_NONE);
         SetIndexStyle(4,DRAW_HISTOGRAM,EMPTY,2);
         SetIndexStyle(5,DRAW_HISTOGRAM,EMPTY,2);
      }
      else
      {
         SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,4);
         SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,4);
         SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,4);
         SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,4);
         SetIndexStyle(4,DRAW_ARROW,EMPTY,2); SetIndexArrow(4,159);
         SetIndexStyle(5,DRAW_ARROW,EMPTY,2); SetIndexArrow(5,159);
      }     

      //
      //
      //
      //
      //
         
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   
      //
      //
      //
      //
      //
      
  IndicatorShortName(timeFrameToString(timeFrame)+" ssa squeeze of "+getAverageName(Method)+" ("+LRegrPeriod+")"); 
   
   return(0);
  }
  
  
int deinit(){return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
   
   double diff,d,dPrev, std,bbs;
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMax(MathMin(Bars-counted_bars,Bars-1),Lag);
         if (returnBars) { upB[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {   
      for(i=limit;i>=0;i--)
      {
      
         d=LinearRegressionValue(LRegrPeriod, i);
         dPrev=LinearRegressionValue(LRegrPeriod,i+1);
      
         value[i] = d;      
         if(d>0) {
            if ((dPrev>0) && (dPrev > d)){ upB2[i]=d; upB[i] = 0; } else { upB[i]= d; upB2[i] = 0; }
        
            loB[i]=0;
            loB2[i]=0;
         
         } else {
      
            if ((dPrev<0) && (dPrev < d)){ loB2[i]=d; loB[i] = 0; } else { loB[i]= d; loB2[i] = 0; }
            upB[i]=0;
            upB2[i]=0;
  
         }
      
         diff = iCustom(NULL,0,"SSA of price",Lag,NumberOfComputations,NumberOfBars,Price,0,i);
         std =  iCustom(NULL,0,"SSA of price",Lag,NumberOfComputations,NumberOfBars,Price,0,i+1);
         bbs = diff-std;
		
         trend[i] = trend[i+1];
            if(bbs > 0) trend[i] =  1;
            if(bbs < 0) trend[i] = -1;
   		if (DataDisplayOff)
         {
            if(bbs < 0) {
               upK[i] = 10;
               loK[i] = EMPTY_VALUE;
            } else {
               loK[i] = 10;
               upK[i] = EMPTY_VALUE;
            }
		   }
         else
		   {
            if(bbs < 0) {
               upK[i] = 0;
               loK[i] = EMPTY_VALUE;
            } else {
               loK[i] = 0;
               upK[i] = EMPTY_VALUE;
            }
         }         
      }
      manageAlerts();
      return(0);
  }
  
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         upB[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LRegrPeriod,Method,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,0,y);
         loB[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LRegrPeriod,Method,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,1,y);
         upB2[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LRegrPeriod,Method,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,2,y);
         loB2[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LRegrPeriod,Method,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,3,y);
         upK[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LRegrPeriod,Method,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,4,y);
         loK[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LRegrPeriod,Method,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,5,y);
         value[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LRegrPeriod,Method,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,6,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LRegrPeriod,Method,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,7,y);
               
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(int k = 1; k < n; k++)
            {
               value[i+k] = value[i] + (value[i+n]-value[i])*k/n;
               if (loB[i]!=0)  loB[i+k]  = value[i+k];
               if (loB2[i]!=0) loB2[i+k] = value[i+k];
               if (upB[i]!=0)  upB[i+k]  = value[i+k];
               if (upB2[i]!=0) upB2[i+k] = value[i+k];
            }
   }
   manageAlerts();
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",getAverageName(Method)," ssa squeeze changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SSA squeeze"+getAverageName(Method)),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double LinearRegressionValue(int Len,int shift) {
   double SumBars = 0;
   double SumSqrBars = 0;
   double SumY = 0;
   double Sum1 = 0;
   double Sum2 = 0;
   double Slope = 0;

   SumBars = Len * (Len-1) * 0.5;
   SumSqrBars = (Len - 1) * Len * (2 * Len - 1)/6;

  for (int x=0; x<=Len-1;x++) {
   double HH = High[x+shift];
   double LL = Low[x+shift];
   for (int y=x; y<=(x+Len)-1; y++) {
     HH = MathMax(HH, High[y+shift]);
     LL = MathMin(LL, Low[y+shift]);
   }
    Sum1 += x* (Close[x+shift]-((HH+LL)/2 + iCustomMA(iMA(NULL,0,1,0,MODE_SMA,Price,x+shift),LRegrPeriod,Method,x+shift))/2);
    SumY +=    (Close[x+shift]-((HH+LL)/2 + iCustomMA(iMA(NULL,0,1,0,MODE_SMA,Price,x+shift),LRegrPeriod,Method,x+shift))/2);
  }
  Sum2 = SumBars * SumY;
  double Num1 = Len * Sum1 - Sum2;
  double Num2 = SumBars * SumBars-Len * SumSqrBars;

  if (Num2 != 0.0)  { 
    Slope = Num1/Num2; 
  } else { 
    Slope = 0; 
  }

  double Intercept = (SumY - Slope*SumBars) /Len;
  double LinearRegValue = Intercept+Slope * (Len - 1);

  return (LinearRegValue);

}


double workPrices[];
double workResult[];
int    r;

double iCustomMA(double price, int period, int method, int i)
{
   if (ArraySize(workPrices)!= Bars) ArrayResize(workPrices,Bars);
            r = Bars-i-1;
   workPrices[r] = price;

   //
   //
   //
   //
   //
   
      switch(method)
      {
         case  0: return(iSma(price,period,i));
         case  1: return(iEma(price,period,i));
         case  2: return(iSmma(price,period,i));
         case  3: return(iLwma(price,period,i));
         case  4: return(iLsma(price,period,i));
         case  5: return(iTma(price,period,i));
         case  6: return(iSineWMA(price,period,i));
         case  7: return(iVolumeWMA(price,period,i));
         case  8: return(iHma(price,period,i));
         case  9: return(iNonLagMa(price,period,i));
      }
   return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iSma(double price, double period, int i)
{
   double sum = 0;
   for(int k=0; k<period && (r-k)>=0; k++) sum += workPrices[r-k];  
   if (k!=0)
         return(sum/k);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEma(double price, double period, int i)
{
   if (ArraySize(workResult)!= Bars) ArrayResize(workResult,Bars);
   double alpha = 2.0 / (1.0+period);
          workResult[r] = workResult[r-1]+alpha*(price-workResult[r-1]);
   return(workResult[r]);
}
//
//
//
//
//

double iSmma(double price, double period, int i)
{
   if (ArraySize(workResult)!= Bars) ArrayResize(workResult,Bars);
   if (i>=(Bars-period))
   {
      double sum = 0; 
         for(int k=0; k<period && (r-k)>=0; k++) sum += workPrices[r-k];  
         if (k!=0)
               workResult[i] = sum/k;
         else  workResult[i] = EMPTY_VALUE;
   }      
   else   workResult[r] = (workResult[r-1]*(period-1)+price)/period;
   return(workResult[r]);
}

//
//
//
//
//

double iLwma.prices[][3];
double iLwma(double price, double period, int i,int forValue=0)
{
   if (ArrayRange(iLwma.prices,0)!= Bars) ArrayResize(iLwma.prices,Bars);
   
   //
   //
   //
   //
   //
   
   iLwma.prices[r][forValue] = price;
      double sum  = 0;
      double sumw = 0;

      for(int k=0; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*iLwma.prices[r-k][forValue];  
      }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iLsma(double price, double period, int i)
{
   return(3.0*iLwma(price,period,i)-2.0*iSma(price,period,i));
}

//
//
//
//
//

double iHma(double price, double period, int i)
{
   int HalfPeriod = MathFloor(period/2);
   int HullPeriod = MathFloor(MathSqrt(period));
            double price1 = 2.0*iLwma(price,HalfPeriod,i,0)-iLwma(price,period,i,1);
   return (iLwma(price1,HullPeriod,i,2));
}

//
//
//
//
//

double iTma(double price, double period, int i)
{
   double half = (period+1.0)/2.0;
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (r-k)>=0; k++)
   {
      double weight = k+1; if (weight > half) weight = period-k;
             sumw  += weight;
             sum   += weight*workPrices[r-k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

#define Pi 3.14159265358979323846
double iSineWMA(double price, int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (r-k)>=0; k++)
   { 
      double weight = MathSin(Pi*(k+1)/(period+1));
             sumw  += weight;
             sum   += weight*workPrices[r-k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iVolumeWMA(double price, int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (r-k)>=0; k++)
   { 
      double weight = Volume[i+k];
             sumw  += weight;
             sum   += weight*workPrices[r-k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

#define numOfSeparateCalculations 1
double  nlm.values[3][numOfSeparateCalculations];
double  nlm.prices[ ][numOfSeparateCalculations];
double  nlm.alphas[ ][numOfSeparateCalculations];

//
//
//
//
//

double iNonLagMa(double price, int length, int i, int forValue=0)
{
   if (ArrayRange(nlm.prices,0) != Bars) ArrayResize(nlm.prices,Bars);
            int r = Bars-i-1;  nlm.prices[r][forValue]=price;
   if (length<3 || r<3) return(nlm.prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_length][forValue] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlm.values[_length][forValue] = length;
         nlm.values[_len   ][forValue] = length*4 + Phase;  
         nlm.values[_weight][forValue] = 0;

         if (ArrayRange(nlm.alphas,0) < nlm.values[_len][forValue]) ArrayResize(nlm.alphas,nlm.values[_len][forValue]);
         for (int k=0; k<nlm.values[_len][forValue]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlm.alphas[k][forValue]        = g * beta;
            nlm.values[_weight][forValue] += nlm.alphas[k][forValue];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_weight][forValue]>0)
   {
      double sum = 0;
           for (k=0; k < nlm.values[_len][forValue]; k++) sum += nlm.alphas[k][forValue]*nlm.prices[r-k][forValue];
           return( sum / nlm.values[_weight][forValue]);
   }
   else return(0);           
}


string methodNames[] = {"SMA","EMA","SMMA","LWMA","LSMA","TriMA","SWMA","VWMA","HullMA","NonLagMA"};
string getAverageName(int& method)
{
   method=MathMax(MathMin(method,9),0); return(methodNames[method]);
}


